'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true

'--- 3 indiciatie LEDS ---
Output PORTD.2 
Output PORTD.3
Output PORTC.4

Symbol LED1 = PORTC.4
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

'--- Verkeerslichten LEDS & RELAIS ---
Output PORTC.6
Output PORTC.7
Output PORTD.4
Output PORTD.5
Output PORTD.6
Output PORTD.7
Output PORTB.0
Output PORTB.1
Output PORTB.2
Output PORTB.3
Output PORTB.4
Output PORTB.5

Symbol XLEDgreen = PORTC.6
Symbol XLEDorange = PORTC.7
Symbol XLEDred = PORTD.4
Symbol XLEDgreenSmall = PORTD.5
Symbol XLEDredSmall = PORTD.6

Symbol YLEDgreen = PORTD.7
Symbol YLEDorange = PORTB.0
Symbol YLEDred = PORTB.1
Symbol YLEDgreenSmall = PORTB.2
Symbol YLEDredSmall = PORTB.3

Symbol XRelais = PORTB.4
Symbol YRelais = PORTB.5

'--- Allerlei ---
Input PORTB.7
Input PORTA.0
Input PORTA.1
Output PORTA.2
Output PORTA.3

Symbol Schakelaar = PORTB.7
Symbol Out1 = PORTA.0
Symbol Out2 = PORTA.1
Symbol In1 = PORTA.2
Symbol In2 = PORTA.3

'--- init ---
GoSub AllLedsOut
Low LED1
Low LED2
Low LED3

DelayMS 250

'--- variables ---
Dim schakelaarMemory As Byte
schakelaarMemory = 5
Dim teller As Byte
Dim factor As Byte

Dim KnipperAanTijd As DWord
Dim KnipperUitTijd As DWord

KnipperAanTijd = 100 * 10
KnipperUitTijd = 100 * 10

factor = 5

'--- MAIN LOOP ---
While 1=1
    If Schakelaar <> schakelaarMemory Then
        schakelaarMemory = Schakelaar
        If Schakelaar = 1 Then
            High LED1
            Low LED2
        Else
            Low LED1
            High LED2
        EndIf
        GoSub AllLedsOut
        High XLEDred
        High XLEDredSmall
        High YLEDred
        High YLEDredSmall
        DelayMS 2000
        GoSub AllLedsOut
    EndIf
    If Schakelaar = 1 Then
        '--- logica voor knipperlichten ---
        High XLEDorange
        High YLEDorange
        DelayMS KnipperAanTijd
        Low XLEDorange
        Low YLEDorange
        DelayMS KnipperUitTijd            
    Else
        '--- logica voor gewone verkeerslichten ---
        '--- zet groen X, rood Y ---
        High YLEDred
        High XLEDredSmall
        Low YLEDredSmall
        High YLEDgreenSmall
        DelayMS 500
        Low XLEDred
        High XLEDgreen
        DelayMS 100
        High XRelais
        DelayMS 22500
        For teller = 1 To 5
            Low YLEDgreenSmall
            DelayMS 250
            High YLEDgreenSmall
            DelayMS 250
        Next teller
        Low YLEDgreenSmall
        High YLEDredSmall
        DelayMS 7500
        Low XLEDgreen
        Low XRelais
        High XLEDorange
        DelayMS 2500
        Low XLEDorange
        High XLEDred
        DelayMS 1000
        '--- zet groen Y, rood X ---
        High XLEDred
        High YLEDredSmall
        Low XLEDredSmall
        High XLEDgreenSmall
        DelayMS 500
        Low YLEDred
        High YLEDgreen
        DelayMS 100
        High YRelais
        DelayMS 22500
        For teller = 1 To 5
            Low XLEDgreenSmall
            DelayMS 250
            High XLEDgreenSmall
            DelayMS 250
        Next teller
        Low XLEDgreenSmall
        High XLEDredSmall
        DelayMS 7500
        Low YLEDgreen
        Low YRelais
        High YLEDorange
        DelayMS 2500
        Low YLEDorange
        High YLEDred
        DelayMS 1000
    EndIf
Wend

AllLedsOut:
    '--- controle LEDs ----
    'LOW LED1
    'LOW led2
    'Low LED3
    
    '--- X-traffic ---
    Low XLEDgreen
    Low XLEDorange
    Low XLEDred
    Low XLEDgreenSmall
    Low XLEDredSmall
    Low XRelais
    
    '--- Y-traffic ---
    Low YLEDgreen
    Low YLEDorange
    Low YLEDred
    Low YLEDgreenSmall
    Low YLEDredSmall
    Low YRelais
    
    
Return
    


